/*
 * channel.c
 */

__asm("	text\n	dc.b	'$Id: channel.c,v 1.2 1998/06/09 12:59:24 sharl Exp $'\n	even\n");

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "config.h"
#include "ircdef.h"
#include "kanji.h"
#include "channel.h"
#include "util.h"

int current_channel = -1;	/*  active ȃ`lԍ */

CHANSTAT chanlist[IRC_JOIN_MAX];

/****************************************
	V`lɐ؂ւ
****************************************/
void
new_channel(int old)
{
	int i;

	for (i = old + 1; i < IRC_JOIN_MAX; i++) {
		if (chanlist[i].active != FALSE) {
			current_channel = i;
			return;
		}
	}
	for (i = 0; i <= old; i++) {
		if (chanlist[i].active != FALSE) {
			current_channel = i;
			return;
		}
	}
	current_channel = -1;
}

/****************************************
	`lXg TOPIC o^
****************************************/
void
set_topic(char *chan, char *topic)
{
	int i;

	for (i = 0; i < IRC_JOIN_MAX; i++) {
		if (!strcmp(chanlist[i].name, chan)) {
			chanlist[i].topic = xrealloc(chanlist[i].topic, strlen(topic) + 1);
			strcpy(chanlist[i].topic, topic);
			return;
		}
	}
}

/****************************************
	ݒ肳ꂽ`l JOIN
****************************************/
void
irc_initial_join(int sock)
{
	int i;
	char buf[BUFSIZ];
	char linebuf[BUFSIZ];

	for (i = 0; i < IRC_JOIN_MAX; i++) {
		chanlist[i].active = FALSE;
		chanlist[i].name = NULL;
		chanlist[i].topic = NULL;
		chanlist[i].isoper = FALSE;
		chanlist[i].visible = TRUE;
	}

	for (i = 0; i < IRC_JOIN_MAX && irc_channel[i]; i++) {
		sjstr2jstr(buf, irc_channel[i]);
		sprintf(linebuf, "JOIN %s\r\n", buf);
#ifdef DEBUG
		if (debug)
			fprintf(stderr, linebuf);
#endif
		write(sock, linebuf, strlen(linebuf));
	}
}

/****************************************
	JOIN
****************************************/
void
join_chanlist(const char *chan)
{
	int i;

	for (i = 0; i < IRC_JOIN_MAX; i++) {
		if (chanlist[i].active == FALSE) {
			current_channel = i;
			chanlist[i].active = TRUE;
			chanlist[i].name = xstrdup(chan);
			return;
		}
	}
}

/****************************************
	PART
****************************************/
void
part_chanlist(const char *chan)
{
	int i;

	for (i = 0; i < IRC_JOIN_MAX; i++) {
		CHANSTAT *p = &chanlist[i];

		if (p->active != FALSE && !strcmp(p->name, chan)) {
			p->active = FALSE;
			free(p->name);
			p->name = NULL;
			if (p->topic) {
				free(p->topic);
				p->topic = NULL;
			}
			p->isoper = FALSE;
			p->visible = TRUE;
			if (i == current_channel)
				new_channel(current_channel);
			return;
		}
	}
}

/****************************************
	KICK
****************************************/

/****************************************
	list JOINed channel
****************************************/
void
list_joined()
{
	int i;

	for (i = 0; i < IRC_JOIN_MAX; i++)
		if (chanlist[i].active)
			printf("%d %s\n", i, chanlist[i].name);
}
