/*
 * config.h
 *
 * $Id: config.h,v 1.9 1998/06/09 13:00:38 sharl Exp $
 */
#ifndef __config_h__
#define __config_h__

#include <sys/types.h>

/* avoid getopt.c does not include string.h */
#define __GNU_LIBRARY__

#define DEFAULT_RC	"." PROGNAME "rc"
#define DEFAULT_RC2	PROGNAME "rc"

#define DEFAULT_PORT	(6667)
#define DEFAULT_TIMEOUT	(3600)

#define RC_AUTOCHANOP		"AUTOCHANOP"
#define RC_AUTONICK			"AUTONICK"
#define RC_CHANNEL			"CHANNEL"
#define RC_IGNORE			"IGNORE"
#define RC_INFO				"INFO"
#define RC_ISON				"ISON"
#define RC_ISON_INTERVAL	"ISON-INTERVAL"
#define RC_LOG_CHANNEL		"LOG-CHANNEL"
#define RC_LOG_DIRECTORY	"LOG-DIRECTORY"
#define RC_LOG_FORMAT		"LOG-FORMAT"
#define RC_NAME				"NAME"
#define RC_NICK				"NICK"
#define RC_KEYWORD			"KEYWORD"
#define RC_KEYWORD_BELL		"KEYWORD-BELL"
#define RC_KEYWORD_BOLD		"KEYWORD-BOLD"
#define RC_PASS				"PASS"
#define RC_PORT				"PORT"
#define RC_QUIT				"QUIT"
#define RC_SERVER			"SERVER"
#define RC_TIMEOUT			"TIMEOUT"
#define RC_USER				"USER"

typedef enum {
	FALSE,
	TRUE,
} BOOLEAN;

typedef enum {
	STR,
	NUM,
} TYPE;

typedef struct {
	char *name;
	TYPE type;
	void *var;
} DIREC;

int ReadConfig(void);

extern char *__progname;

extern char *irc_server;
extern char *irc_pass;
extern int irc_port;
extern char *irc_nick;
extern char *irc_user;
extern char *irc_name;
extern char *irc_info;
extern char *irc_quit_message;
extern time_t irc_timeout;
extern char *irc_keyword;
extern char *irc_keyword_bell;
extern char *irc_keyword_bold;
extern char *irc_autochanops;
extern char **irc_autochanop;
extern char *irc_autonicks;
extern char **irc_autonick;
extern char *irc_channel[];

extern char *keyword_bell;
extern size_t bell_length;
extern DIREC directive[];

#ifdef DEBUG
extern int debug;
#endif

#endif
